
module Control.Monad
    {M : Set -> Set}
    (ret  : {A : Set} -> A -> M A)
    (bind : {A B : Set} -> M A -> (A -> M B) -> M B)
  where

infixr 5 _>>=_ _>>_

_>>=_ : {A B : Set} -> M A -> (A -> M B) -> M B
_>>=_ = bind

return : {A : Set} -> A -> M A
return = ret

_>>_ : {A B : Set} -> M A -> M B -> M B
m₁ >> m₂ = m₁ >>= \_ -> m₂
